/*************************************************************
 * This file was automatically generated on 2012-05-09.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	public class BrickServo : Device 
	{
		private static byte TYPE_ENABLE = 1;
		private static byte TYPE_DISABLE = 2;
		private static byte TYPE_IS_ENABLED = 3;
		private static byte TYPE_SET_POSITION = 4;
		private static byte TYPE_GET_POSITION = 5;
		private static byte TYPE_GET_CURRENT_POSITION = 6;
		private static byte TYPE_SET_VELOCITY = 7;
		private static byte TYPE_GET_VELOCITY = 8;
		private static byte TYPE_GET_CURRENT_VELOCITY = 9;
		private static byte TYPE_SET_ACCELERATION = 10;
		private static byte TYPE_GET_ACCELERATION = 11;
		private static byte TYPE_SET_OUTPUT_VOLTAGE = 12;
		private static byte TYPE_GET_OUTPUT_VOLTAGE = 13;
		private static byte TYPE_SET_PULSE_WIDTH = 14;
		private static byte TYPE_GET_PULSE_WIDTH = 15;
		private static byte TYPE_SET_DEGREE = 16;
		private static byte TYPE_GET_DEGREE = 17;
		private static byte TYPE_SET_PERIOD = 18;
		private static byte TYPE_GET_PERIOD = 19;
		private static byte TYPE_GET_SERVO_CURRENT = 20;
		private static byte TYPE_GET_OVERALL_CURRENT = 21;
		private static byte TYPE_GET_STACK_INPUT_VOLTAGE = 22;
		private static byte TYPE_GET_EXTERNAL_INPUT_VOLTAGE = 23;
		private static byte TYPE_SET_MINIMUM_VOLTAGE = 24;
		private static byte TYPE_GET_MINIMUM_VOLTAGE = 25;
		private static byte TYPE_UNDER_VOLTAGE = 26;
		private static byte TYPE_POSITION_REACHED = 27;
		private static byte TYPE_VELOCITY_REACHED = 28;

		public delegate void UnderVoltage(ushort voltage);
		public delegate void PositionReached(byte servoNum, short position);
		public delegate void VelocityReached(byte servoNum, short velocity);

		public BrickServo(string uid) : base(uid) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[TYPE_UNDER_VOLTAGE] = new MessageCallback(CallbackUnderVoltage);
			messageCallbacks[TYPE_POSITION_REACHED] = new MessageCallback(CallbackPositionReached);
			messageCallbacks[TYPE_VELOCITY_REACHED] = new MessageCallback(CallbackVelocityReached);
		}

		public void Enable(byte servoNum)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_ENABLE, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(servoNum, 4, data_);

			sendOneWayMessage(data_);
		}

		public void Disable(byte servoNum)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_DISABLE, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(servoNum, 4, data_);

			sendOneWayMessage(data_);
		}

		public bool IsEnabled(byte servoNum)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_IS_ENABLED, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(servoNum, 4, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_IS_ENABLED, out answer);

			return LEConverter.BoolFrom(4, answer);
		}

		public void SetPosition(byte servoNum, short position)
		{
			byte[] data_ = new byte[7];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_POSITION, 1, data_);
			LEConverter.To((ushort)7, 2, data_);
			LEConverter.To(servoNum, 4, data_);
			LEConverter.To(position, 5, data_);

			sendOneWayMessage(data_);
		}

		public short GetPosition(byte servoNum)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_POSITION, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(servoNum, 4, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_POSITION, out answer);

			return LEConverter.ShortFrom(4, answer);
		}

		public short GetCurrentPosition(byte servoNum)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CURRENT_POSITION, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(servoNum, 4, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_CURRENT_POSITION, out answer);

			return LEConverter.ShortFrom(4, answer);
		}

		public void SetVelocity(byte servoNum, ushort velocity)
		{
			byte[] data_ = new byte[7];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_VELOCITY, 1, data_);
			LEConverter.To((ushort)7, 2, data_);
			LEConverter.To(servoNum, 4, data_);
			LEConverter.To(velocity, 5, data_);

			sendOneWayMessage(data_);
		}

		public ushort GetVelocity(byte servoNum)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_VELOCITY, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(servoNum, 4, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_VELOCITY, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public ushort GetCurrentVelocity(byte servoNum)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CURRENT_VELOCITY, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(servoNum, 4, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_CURRENT_VELOCITY, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public void SetAcceleration(byte servoNum, ushort acceleration)
		{
			byte[] data_ = new byte[7];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_ACCELERATION, 1, data_);
			LEConverter.To((ushort)7, 2, data_);
			LEConverter.To(servoNum, 4, data_);
			LEConverter.To(acceleration, 5, data_);

			sendOneWayMessage(data_);
		}

		public ushort GetAcceleration(byte servoNum)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_ACCELERATION, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(servoNum, 4, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_ACCELERATION, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public void SetOutputVoltage(ushort voltage)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_OUTPUT_VOLTAGE, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(voltage, 4, data_);

			sendOneWayMessage(data_);
		}

		public ushort GetOutputVoltage()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_OUTPUT_VOLTAGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_OUTPUT_VOLTAGE, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public void SetPulseWidth(byte servoNum, ushort min, ushort max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_PULSE_WIDTH, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(servoNum, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);

			sendOneWayMessage(data_);
		}

		public void GetPulseWidth(byte servoNum, out ushort min, out ushort max)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_PULSE_WIDTH, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(servoNum, 4, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_PULSE_WIDTH, out answer);

			min = LEConverter.UShortFrom(4, answer);
			max = LEConverter.UShortFrom(6, answer);
		}

		public void SetDegree(byte servoNum, short min, short max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_DEGREE, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(servoNum, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);

			sendOneWayMessage(data_);
		}

		public void GetDegree(byte servoNum, out short min, out short max)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_DEGREE, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(servoNum, 4, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_DEGREE, out answer);

			min = LEConverter.ShortFrom(4, answer);
			max = LEConverter.ShortFrom(6, answer);
		}

		public void SetPeriod(byte servoNum, ushort period)
		{
			byte[] data_ = new byte[7];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_PERIOD, 1, data_);
			LEConverter.To((ushort)7, 2, data_);
			LEConverter.To(servoNum, 4, data_);
			LEConverter.To(period, 5, data_);

			sendOneWayMessage(data_);
		}

		public ushort GetPeriod(byte servoNum)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_PERIOD, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(servoNum, 4, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_PERIOD, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public ushort GetServoCurrent(byte servoNum)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_SERVO_CURRENT, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(servoNum, 4, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_SERVO_CURRENT, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public ushort GetOverallCurrent()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_OVERALL_CURRENT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_OVERALL_CURRENT, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public ushort GetStackInputVoltage()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_STACK_INPUT_VOLTAGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_STACK_INPUT_VOLTAGE, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public ushort GetExternalInputVoltage()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_EXTERNAL_INPUT_VOLTAGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_EXTERNAL_INPUT_VOLTAGE, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public void SetMinimumVoltage(ushort voltage)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_MINIMUM_VOLTAGE, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(voltage, 4, data_);

			sendOneWayMessage(data_);
		}

		public ushort GetMinimumVoltage()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_MINIMUM_VOLTAGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_MINIMUM_VOLTAGE, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		[Obsolete()]
		public void IsEnabled(byte servoNum, out bool enabled)
		{
			enabled = IsEnabled(servoNum);
		}

		[Obsolete()]
		public void GetPosition(byte servoNum, out short position)
		{
			position = GetPosition(servoNum);
		}

		[Obsolete()]
		public void GetCurrentPosition(byte servoNum, out short position)
		{
			position = GetCurrentPosition(servoNum);
		}

		[Obsolete()]
		public void GetVelocity(byte servoNum, out ushort velocity)
		{
			velocity = GetVelocity(servoNum);
		}

		[Obsolete()]
		public void GetCurrentVelocity(byte servoNum, out ushort velocity)
		{
			velocity = GetCurrentVelocity(servoNum);
		}

		[Obsolete()]
		public void GetAcceleration(byte servoNum, out ushort acceleration)
		{
			acceleration = GetAcceleration(servoNum);
		}

		[Obsolete()]
		public void GetOutputVoltage(out ushort voltage)
		{
			voltage = GetOutputVoltage();
		}

		[Obsolete()]
		public void GetPeriod(byte servoNum, out ushort period)
		{
			period = GetPeriod(servoNum);
		}

		[Obsolete()]
		public void GetServoCurrent(byte servoNum, out ushort current)
		{
			current = GetServoCurrent(servoNum);
		}

		[Obsolete()]
		public void GetOverallCurrent(out ushort current)
		{
			current = GetOverallCurrent();
		}

		[Obsolete()]
		public void GetStackInputVoltage(out ushort voltage)
		{
			voltage = GetStackInputVoltage();
		}

		[Obsolete()]
		public void GetExternalInputVoltage(out ushort voltage)
		{
			voltage = GetExternalInputVoltage();
		}

		[Obsolete()]
		public void GetMinimumVoltage(out ushort voltage)
		{
			voltage = GetMinimumVoltage();
		}

		public void GetVersion(out string name, out byte[] firmwareVersion, out byte[] bindingVersion)
		{{
			name = this.name;
			firmwareVersion = this.firmwareVersion;
			bindingVersion = this.bindingVersion;
		}}

		internal int CallbackUnderVoltage(byte[] data_)
		{
			ushort voltage = LEConverter.UShortFrom(4, data_);

			((UnderVoltage)callbacks[TYPE_UNDER_VOLTAGE])(voltage);
			return 6;
		}

		internal int CallbackPositionReached(byte[] data_)
		{
			byte servoNum = LEConverter.ByteFrom(4, data_);
			short position = LEConverter.ShortFrom(5, data_);

			((PositionReached)callbacks[TYPE_POSITION_REACHED])(servoNum, position);
			return 7;
		}

		internal int CallbackVelocityReached(byte[] data_)
		{
			byte servoNum = LEConverter.ByteFrom(4, data_);
			short velocity = LEConverter.ShortFrom(5, data_);

			((VelocityReached)callbacks[TYPE_VELOCITY_REACHED])(servoNum, velocity);
			return 7;
		}

		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(UnderVoltage))
			{
				callbacks[TYPE_UNDER_VOLTAGE] = d;
			}
			else if(d.GetType() == typeof(PositionReached))
			{
				callbacks[TYPE_POSITION_REACHED] = d;
			}
			else if(d.GetType() == typeof(VelocityReached))
			{
				callbacks[TYPE_VELOCITY_REACHED] = d;
			}
		}
	}
}
