/*************************************************************
 * This file was automatically generated on 2012-05-09.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	public class BrickStepper : Device 
	{
		private static byte TYPE_SET_MAX_VELOCITY = 1;
		private static byte TYPE_GET_MAX_VELOCITY = 2;
		private static byte TYPE_GET_CURRENT_VELOCITY = 3;
		private static byte TYPE_SET_SPEED_RAMPING = 4;
		private static byte TYPE_GET_SPEED_RAMPING = 5;
		private static byte TYPE_FULL_BRAKE = 6;
		private static byte TYPE_SET_CURRENT_POSITION = 7;
		private static byte TYPE_GET_CURRENT_POSITION = 8;
		private static byte TYPE_SET_TARGET_POSITION = 9;
		private static byte TYPE_GET_TARGET_POSITION = 10;
		private static byte TYPE_SET_STEPS = 11;
		private static byte TYPE_GET_STEPS = 12;
		private static byte TYPE_GET_REMAINING_STEPS = 13;
		private static byte TYPE_SET_STEP_MODE = 14;
		private static byte TYPE_GET_STEP_MODE = 15;
		private static byte TYPE_DRIVE_FORWARD = 16;
		private static byte TYPE_DRIVE_BACKWARD = 17;
		private static byte TYPE_STOP = 18;
		private static byte TYPE_GET_STACK_INPUT_VOLTAGE = 19;
		private static byte TYPE_GET_EXTERNAL_INPUT_VOLTAGE = 20;
		private static byte TYPE_GET_CURRENT_CONSUMPTION = 21;
		private static byte TYPE_SET_MOTOR_CURRENT = 22;
		private static byte TYPE_GET_MOTOR_CURRENT = 23;
		private static byte TYPE_ENABLE = 24;
		private static byte TYPE_DISABLE = 25;
		private static byte TYPE_IS_ENABLED = 26;
		private static byte TYPE_SET_DECAY = 27;
		private static byte TYPE_GET_DECAY = 28;
		private static byte TYPE_SET_MINIMUM_VOLTAGE = 29;
		private static byte TYPE_GET_MINIMUM_VOLTAGE = 30;
		private static byte TYPE_UNDER_VOLTAGE = 31;
		private static byte TYPE_POSITION_REACHED = 32;
		private static byte TYPE_SET_SYNC_RECT = 33;
		private static byte TYPE_IS_SYNC_RECT = 34;

		public delegate void UnderVoltage(ushort voltage);
		public delegate void PositionReached(int position);

		public BrickStepper(string uid) : base(uid) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[TYPE_UNDER_VOLTAGE] = new MessageCallback(CallbackUnderVoltage);
			messageCallbacks[TYPE_POSITION_REACHED] = new MessageCallback(CallbackPositionReached);
		}

		public void SetMaxVelocity(ushort velocity)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_MAX_VELOCITY, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(velocity, 4, data_);

			sendOneWayMessage(data_);
		}

		public ushort GetMaxVelocity()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_MAX_VELOCITY, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_MAX_VELOCITY, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public ushort GetCurrentVelocity()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CURRENT_VELOCITY, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_CURRENT_VELOCITY, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public void SetSpeedRamping(ushort acceleration, ushort deacceleration)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_SPEED_RAMPING, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(acceleration, 4, data_);
			LEConverter.To(deacceleration, 6, data_);

			sendOneWayMessage(data_);
		}

		public void GetSpeedRamping(out ushort acceleration, out ushort deacceleration)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_SPEED_RAMPING, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_SPEED_RAMPING, out answer);

			acceleration = LEConverter.UShortFrom(4, answer);
			deacceleration = LEConverter.UShortFrom(6, answer);
		}

		public void FullBrake()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_FULL_BRAKE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			sendOneWayMessage(data_);
		}

		public void SetCurrentPosition(int position)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_CURRENT_POSITION, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(position, 4, data_);

			sendOneWayMessage(data_);
		}

		public int GetCurrentPosition()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CURRENT_POSITION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_CURRENT_POSITION, out answer);

			return LEConverter.IntFrom(4, answer);
		}

		public void SetTargetPosition(int position)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_TARGET_POSITION, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(position, 4, data_);

			sendOneWayMessage(data_);
		}

		public int GetTargetPosition()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_TARGET_POSITION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_TARGET_POSITION, out answer);

			return LEConverter.IntFrom(4, answer);
		}

		public void SetSteps(int steps)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_STEPS, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(steps, 4, data_);

			sendOneWayMessage(data_);
		}

		public int GetSteps()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_STEPS, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_STEPS, out answer);

			return LEConverter.IntFrom(4, answer);
		}

		public int GetRemainingSteps()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_REMAINING_STEPS, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_REMAINING_STEPS, out answer);

			return LEConverter.IntFrom(4, answer);
		}

		public void SetStepMode(byte mode)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_STEP_MODE, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(mode, 4, data_);

			sendOneWayMessage(data_);
		}

		public byte GetStepMode()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_STEP_MODE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_STEP_MODE, out answer);

			return LEConverter.ByteFrom(4, answer);
		}

		public void DriveForward()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_DRIVE_FORWARD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			sendOneWayMessage(data_);
		}

		public void DriveBackward()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_DRIVE_BACKWARD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			sendOneWayMessage(data_);
		}

		public void Stop()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_STOP, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			sendOneWayMessage(data_);
		}

		public ushort GetStackInputVoltage()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_STACK_INPUT_VOLTAGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_STACK_INPUT_VOLTAGE, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public ushort GetExternalInputVoltage()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_EXTERNAL_INPUT_VOLTAGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_EXTERNAL_INPUT_VOLTAGE, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public ushort GetCurrentConsumption()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CURRENT_CONSUMPTION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_CURRENT_CONSUMPTION, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public void SetMotorCurrent(ushort current)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_MOTOR_CURRENT, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(current, 4, data_);

			sendOneWayMessage(data_);
		}

		public ushort GetMotorCurrent()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_MOTOR_CURRENT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_MOTOR_CURRENT, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public void Enable()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_ENABLE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			sendOneWayMessage(data_);
		}

		public void Disable()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_DISABLE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			sendOneWayMessage(data_);
		}

		public bool IsEnabled()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_IS_ENABLED, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_IS_ENABLED, out answer);

			return LEConverter.BoolFrom(4, answer);
		}

		public void SetDecay(ushort decay)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_DECAY, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(decay, 4, data_);

			sendOneWayMessage(data_);
		}

		public ushort GetDecay()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_DECAY, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_DECAY, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public void SetMinimumVoltage(ushort voltage)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_MINIMUM_VOLTAGE, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(voltage, 4, data_);

			sendOneWayMessage(data_);
		}

		public ushort GetMinimumVoltage()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_MINIMUM_VOLTAGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_MINIMUM_VOLTAGE, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		public void SetSyncRect(bool syncRect)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_SYNC_RECT, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(syncRect, 4, data_);

			sendOneWayMessage(data_);
		}

		public bool IsSyncRect()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_IS_SYNC_RECT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_IS_SYNC_RECT, out answer);

			return LEConverter.BoolFrom(4, answer);
		}

		[Obsolete()]
		public void GetMaxVelocity(out ushort velocity)
		{
			velocity = GetMaxVelocity();
		}

		[Obsolete()]
		public void GetCurrentVelocity(out ushort velocity)
		{
			velocity = GetCurrentVelocity();
		}

		[Obsolete()]
		public void GetCurrentPosition(out int position)
		{
			position = GetCurrentPosition();
		}

		[Obsolete()]
		public void GetTargetPosition(out int position)
		{
			position = GetTargetPosition();
		}

		[Obsolete()]
		public void GetSteps(out int steps)
		{
			steps = GetSteps();
		}

		[Obsolete()]
		public void GetRemainingSteps(out int steps)
		{
			steps = GetRemainingSteps();
		}

		[Obsolete()]
		public void GetStepMode(out byte mode)
		{
			mode = GetStepMode();
		}

		[Obsolete()]
		public void GetStackInputVoltage(out ushort voltage)
		{
			voltage = GetStackInputVoltage();
		}

		[Obsolete()]
		public void GetExternalInputVoltage(out ushort voltage)
		{
			voltage = GetExternalInputVoltage();
		}

		[Obsolete()]
		public void GetCurrentConsumption(out ushort current)
		{
			current = GetCurrentConsumption();
		}

		[Obsolete()]
		public void GetMotorCurrent(out ushort current)
		{
			current = GetMotorCurrent();
		}

		[Obsolete()]
		public void IsEnabled(out bool enabled)
		{
			enabled = IsEnabled();
		}

		[Obsolete()]
		public void GetDecay(out ushort decay)
		{
			decay = GetDecay();
		}

		[Obsolete()]
		public void GetMinimumVoltage(out ushort voltage)
		{
			voltage = GetMinimumVoltage();
		}

		[Obsolete()]
		public void IsSyncRect(out bool syncRect)
		{
			syncRect = IsSyncRect();
		}

		public void GetVersion(out string name, out byte[] firmwareVersion, out byte[] bindingVersion)
		{{
			name = this.name;
			firmwareVersion = this.firmwareVersion;
			bindingVersion = this.bindingVersion;
		}}

		internal int CallbackUnderVoltage(byte[] data_)
		{
			ushort voltage = LEConverter.UShortFrom(4, data_);

			((UnderVoltage)callbacks[TYPE_UNDER_VOLTAGE])(voltage);
			return 6;
		}

		internal int CallbackPositionReached(byte[] data_)
		{
			int position = LEConverter.IntFrom(4, data_);

			((PositionReached)callbacks[TYPE_POSITION_REACHED])(position);
			return 8;
		}

		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(UnderVoltage))
			{
				callbacks[TYPE_UNDER_VOLTAGE] = d;
			}
			else if(d.GetType() == typeof(PositionReached))
			{
				callbacks[TYPE_POSITION_REACHED] = d;
			}
		}
	}
}
