/*************************************************************
 * This file was automatically generated on 2012-05-09.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	public class BrickletIO16 : Device 
	{
		private static byte TYPE_SET_PORT = 1;
		private static byte TYPE_GET_PORT = 2;
		private static byte TYPE_SET_PORT_CONFIGURATION = 3;
		private static byte TYPE_GET_PORT_CONFIGURATION = 4;
		private static byte TYPE_SET_DEBOUNCE_PERIOD = 5;
		private static byte TYPE_GET_DEBOUNCE_PERIOD = 6;
		private static byte TYPE_SET_PORT_INTERRUPT = 7;
		private static byte TYPE_GET_PORT_INTERRUPT = 8;
		private static byte TYPE_INTERRUPT = 9;

		public delegate void Interrupt(char port, byte interruptMask, byte valueMask);

		public BrickletIO16(string uid) : base(uid) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[TYPE_INTERRUPT] = new MessageCallback(CallbackInterrupt);
		}

		public void SetPort(char port, byte valueMask)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_PORT, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(port, 4, data_);
			LEConverter.To(valueMask, 5, data_);

			sendOneWayMessage(data_);
		}

		public byte GetPort(char port)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_PORT, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(port, 4, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_PORT, out answer);

			return LEConverter.ByteFrom(4, answer);
		}

		public void SetPortConfiguration(char port, byte portMask, char direction, bool value)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_PORT_CONFIGURATION, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(port, 4, data_);
			LEConverter.To(portMask, 5, data_);
			LEConverter.To(direction, 6, data_);
			LEConverter.To(value, 7, data_);

			sendOneWayMessage(data_);
		}

		public void GetPortConfiguration(char port, out byte directionMask, out byte valueMask)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_PORT_CONFIGURATION, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(port, 4, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_PORT_CONFIGURATION, out answer);

			directionMask = LEConverter.ByteFrom(4, answer);
			valueMask = LEConverter.ByteFrom(5, answer);
		}

		public void SetDebouncePeriod(uint debounce)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(debounce, 4, data_);

			sendOneWayMessage(data_);
		}

		public uint GetDebouncePeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_DEBOUNCE_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		public void SetPortInterrupt(char port, byte interruptMask)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_PORT_INTERRUPT, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(port, 4, data_);
			LEConverter.To(interruptMask, 5, data_);

			sendOneWayMessage(data_);
		}

		public byte GetPortInterrupt(char port)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_PORT_INTERRUPT, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(port, 4, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_PORT_INTERRUPT, out answer);

			return LEConverter.ByteFrom(4, answer);
		}

		[Obsolete()]
		public void GetPort(char port, out byte valueMask)
		{
			valueMask = GetPort(port);
		}

		[Obsolete()]
		public void GetDebouncePeriod(out uint debounce)
		{
			debounce = GetDebouncePeriod();
		}

		[Obsolete()]
		public void GetPortInterrupt(char port, out byte interruptMask)
		{
			interruptMask = GetPortInterrupt(port);
		}

		public void GetVersion(out string name, out byte[] firmwareVersion, out byte[] bindingVersion)
		{{
			name = this.name;
			firmwareVersion = this.firmwareVersion;
			bindingVersion = this.bindingVersion;
		}}

		internal int CallbackInterrupt(byte[] data_)
		{
			char port = LEConverter.CharFrom(4, data_);
			byte interruptMask = LEConverter.ByteFrom(5, data_);
			byte valueMask = LEConverter.ByteFrom(6, data_);

			((Interrupt)callbacks[TYPE_INTERRUPT])(port, interruptMask, valueMask);
			return 7;
		}

		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(Interrupt))
			{
				callbacks[TYPE_INTERRUPT] = d;
			}
		}
	}
}
