/*************************************************************
 * This file was automatically generated on 2012-05-09.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	public class BrickletTemperature : Device 
	{
		private static byte TYPE_GET_TEMPERATURE = 1;
		private static byte TYPE_SET_TEMPERATURE_CALLBACK_PERIOD = 2;
		private static byte TYPE_GET_TEMPERATURE_CALLBACK_PERIOD = 3;
		private static byte TYPE_SET_TEMPERATURE_CALLBACK_THRESHOLD = 4;
		private static byte TYPE_GET_TEMPERATURE_CALLBACK_THRESHOLD = 5;
		private static byte TYPE_SET_DEBOUNCE_PERIOD = 6;
		private static byte TYPE_GET_DEBOUNCE_PERIOD = 7;
		private static byte TYPE_TEMPERATURE = 8;
		private static byte TYPE_TEMPERATURE_REACHED = 9;

		public delegate void Temperature(short temperature);
		public delegate void TemperatureReached(short temperature);

		public BrickletTemperature(string uid) : base(uid) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[TYPE_TEMPERATURE] = new MessageCallback(CallbackTemperature);
			messageCallbacks[TYPE_TEMPERATURE_REACHED] = new MessageCallback(CallbackTemperatureReached);
		}

		public short GetTemperature()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_TEMPERATURE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_TEMPERATURE, out answer);

			return LEConverter.ShortFrom(4, answer);
		}

		public void SetTemperatureCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_TEMPERATURE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			sendOneWayMessage(data_);
		}

		public uint GetTemperatureCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_TEMPERATURE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_TEMPERATURE_CALLBACK_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		public void SetTemperatureCallbackThreshold(char option, short min, short max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_TEMPERATURE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);

			sendOneWayMessage(data_);
		}

		public void GetTemperatureCallbackThreshold(out char option, out short min, out short max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_TEMPERATURE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_TEMPERATURE_CALLBACK_THRESHOLD, out answer);

			option = LEConverter.CharFrom(4, answer);
			min = LEConverter.ShortFrom(5, answer);
			max = LEConverter.ShortFrom(7, answer);
		}

		public void SetDebouncePeriod(uint debounce)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(debounce, 4, data_);

			sendOneWayMessage(data_);
		}

		public uint GetDebouncePeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, TYPE_GET_DEBOUNCE_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		[Obsolete()]
		public void GetTemperature(out short temperature)
		{
			temperature = GetTemperature();
		}

		[Obsolete()]
		public void GetTemperatureCallbackPeriod(out uint period)
		{
			period = GetTemperatureCallbackPeriod();
		}

		[Obsolete()]
		public void GetDebouncePeriod(out uint debounce)
		{
			debounce = GetDebouncePeriod();
		}

		public void GetVersion(out string name, out byte[] firmwareVersion, out byte[] bindingVersion)
		{{
			name = this.name;
			firmwareVersion = this.firmwareVersion;
			bindingVersion = this.bindingVersion;
		}}

		internal int CallbackTemperature(byte[] data_)
		{
			short temperature = LEConverter.ShortFrom(4, data_);

			((Temperature)callbacks[TYPE_TEMPERATURE])(temperature);
			return 6;
		}

		internal int CallbackTemperatureReached(byte[] data_)
		{
			short temperature = LEConverter.ShortFrom(4, data_);

			((TemperatureReached)callbacks[TYPE_TEMPERATURE_REACHED])(temperature);
			return 6;
		}

		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(Temperature))
			{
				callbacks[TYPE_TEMPERATURE] = d;
			}
			else if(d.GetType() == typeof(TemperatureReached))
			{
				callbacks[TYPE_TEMPERATURE_REACHED] = d;
			}
		}
	}
}
